// +-------------------------------------------+
// |  ___   _     _____   __  __  ____   ____  |
// | | __| | |   | /_\ |  \ \/ / | ___| | /\ | |
// | |__ | | |_  |  _  |   \  /  | __|  | \/ / |
// | |___| |___| |_| |_|   |__|  |____| |_| \\ |
// |  Greek2me              Blockland ID 11902 |
// +-------------------------------------------+

if(forceRequiredAddon("Gamemode_Slayer") == $Error::Addon_NotFound)
{
	error("ERROR: Server_TeamLifeTickets - Required add-on Gamemode_Slayer not found!");
	return;
}

new ScriptObject(Slayer_TeamPrefSO : Slayer_DefaultTeamPrefSO)
{
	category = "Team";
	title = "Team Life Tickets";
	defaultValue = 0;
	permissionLevel = $Slayer::PermissionLevel["Any"];
	variable = "teamLifeTickets";
	type = "int";
	int_minValue = 0;
	int_maxValue = 999;
	guiTag = "Advanced";
};

function Slayer_TeamSO::addLifeTickets(%this, %lives)
{
	%this.remainingLifeTickets += %lives;
}

function Slayer_TeamSO::setLifeTickets(%this, %lives)
{
	%this.remainingLifeTickets = %lives;
}

package Slayer_Modules_TLT
{
	function GameConnection::onDeath(%client,%obj,%killer,%type,%area)
	{
		%mini = getMinigameFromObject(%client);
		if(isSlayerMinigame(%mini))
		{
			%team = %client.getTeam();
			if(isObject(%team))
			{
				if(%team.teamLifeTickets > 0)
				{
					%team.remainingLifeTickets --;

					if(%team.remainingLifeTickets <= 0)
					{
						%client.setDead(1);
						%client.schedule(0,centerPrint,"<just:center>\c5Your team is out of Life Tickets. You cannot respawn.",5);
					}

					%client.bottomPrint("<just:center>\c5Your team has\c3" SPC %team.remainingLifeTickets SPC (%team.remainingLifeTickets == 1 ? "\c5Life Ticket" : "\c5Life Tickets") SPC "remaining.",5);
				}
			}
		}

		return parent::onDeath(%client,%obj,%killer,%type,%area);
	}

	function MinigameSO::Reset(%this,%client)
	{
		if(isSlayerMinigame(%this))
		{
			for(%i=0; %i < %this.Teams.getCount(); %i++)
			{
				%team = %this.Teams.getObject(%i);
				%team.remainingLifeTickets = %team.teamLifeTickets;
			}
		}

		return parent::reset(%this,%client);
	}

	function Slayer_TeamSO::isTeamDead(%this)
	{
		if(%this.teamLifeTickets > 0)
		{
			if(%this.remainingLifeTickets <= 0 && %this.getSpawned() <= 0)
			{
				return 1;
			}
		}

		return parent::isTeamDead(%this);
	}
	
	function Slayer::createBrickEvents(%this)
	{
		parent::createBrickEvents(%this);
		registerOutputEvent(Slayer_TeamSO, "addLifeTickets", "int 0 200 1");
		registerOutputEvent(Slayer_TeamSO, "setLifeTickets", "int 0 200 1");
	}
};
activatePackage(Slayer_Modules_TLT);